/*-
 * Copyright (c) Heisei 9-10(1997-1998) YASUI Tsukasa
 * Copyright (c) 2003 Nuno S. Antunes.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

/*
 * Serial communication Routine Sample File for SH7604
 */
		.equ	SCI_BASE,	0xfffffe00	! SCI1 Base Addr
		.equ	SCI_ASTEP,	1		! if CPU is SH7708 then set SCI_ASTEP "2"


		.equ	O_SMR,		0x00*SCI_ASTEP
		.equ	O_BBR,		0x01*SCI_ASTEP
		.equ	O_SCR,		0x02*SCI_ASTEP
		.equ	O_TDR,		0x03*SCI_ASTEP
		.equ	O_SSR,		0x04*SCI_ASTEP
		.equ	O_RDR,		0x05*SCI_ASTEP
		.equ	TDRE_BIT,	0x84
		.equ	TDRE_CLR,	0x7f
		.equ	RDRF_BIT,	0x40
		.equ	RDRF_CLR,	0xbf
		.equ	SMR_DEFAULT,	0x00
		.equ	SCR_DEFAULT,	0x00

		.global	__sciinit
		.global	__scisend
		.global	__scirecv
		.text
		.align	2

! void _sciinit(int baud);
__sciinit:	stc	gbr,r1
		mov.l	L_SCI_BASE,r0
		ldc	r0,gbr
		mov	#O_SSR,r0		
__sciinit1:	mov	r4,r0
		mov.b	r0,@(O_BBR,gbr)				!0_TDR=3
		mov	#SMR_DEFAULT,r0
		mov.b	r0,@(O_SMR,gbr)
		mov	#SCR_DEFAULT,r0
		mov.b	r0,@(O_SCR,gbr)
		rts
		ldc	r1,gbr

! void _scisend(int txdata);
__scisend:	stc	gbr,r1
		mov.l	L_SCI_BASE,r0
		ldc	r0,gbr
		mov	#O_SSR,r0
__scisend1:
		tst.b	#TDRE_BIT,@(r0,gbr)		!TDRE_BIT=0x80
		bt	__scisend1

		mov	r4,r0
		mov.b	r0,@(O_TDR,gbr)				!0_TDR=3
		mov	#O_SSR,r0
		and.b	#TDRE_CLR,@(r0,gbr)			!TDRE_CLR=0x7f
		rts
		ldc	r1,gbr

! int _scirecv(void);
__scirecv:
		stc	gbr,r2
		mov.l	L_SCI_BASE,r0
		ldc	r0,gbr
		mov	#O_SSR,r0
__scirecv1:
		tst.b	#RDRF_BIT,@(r0,gbr)		!RDRF_BIT=0x40
		bt	__scirecv1

		mov.b	@(O_RDR,gbr),r0
		extu.b	r0,r1
		mov	#O_SSR,r0
		and.b	#RDRF_CLR,@(r0,gbr)		!RDRF_CLR=0xbf
		mov	r1,r0
		rts
		ldc	r2,gbr


		.align	2
L_SCI_BASE:	.long	SCI_BASE

		.end
